{
  description = "Prymn";

  inputs = {
    nixpkgs.url = "github:NixOS/nixpkgs/nixpkgs-unstable";
    flake-utils.url = "github:numtide/flake-utils";
    rust-overlay = {
      url = "github:oxalica/rust-overlay";
      inputs.nixpkgs.follows = "nixpkgs";
      inputs.flake-utils.follows = "flake-utils";
    };
  };

  outputs = { self, nixpkgs, flake-utils, rust-overlay }: flake-utils.lib.eachDefaultSystem (system:
    let
      pkgs = import nixpkgs { inherit system overlays; };
      overlays = [ (import ./nix/overlay.nix) (import rust-overlay) ];
      scripts = pkgs.callPackage ./nix/scripts.nix { };
    in
    {
      devShells.default = with pkgs; mkShell {
        packages = [
          elixir
          elixir-ls
          rustToolchain
          protobuf
          protoc-gen-elixir
          scripts.prymn_db
        ] ++ lib.optionals stdenv.isLinux [ inotify-tools ];

        shellHook = ''
          export PROJECT_ROOT_DIR="$PWD"
        '';
      };
    });
}
